package org.olga.rebus.gui.creation;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import org.olga.rebus.gui.RebusForm;

/**
 * -    .
 * 
 * @author Olga
 *
 */
public class CreateRebus extends JFrame {
	private static final long serialVersionUID = 1L;
	//    
	private GraphPaper myGraphPaper;
	//     
	private CreateWords myWordsPanel;
	// 
	private JPanel myGraphPanel;
	//,   
	private JButton myNextButton;
	//,   
	private JButton myBackButton;
	
	//,     
	private RebusForm myFrame;
	
	//,    
	private int myStep;
	
	//
	private Repainter myRepainter = new Repainter();

	/*
	 * ,   0.
	 */
	private void step0() {
		myGraphPanel.removeAll();
		myGraphPanel.add(new JScrollPane(myGraphPaper));
		myGraphPanel.add(myGraphPaper.getTools());
		
		myBackButton.setVisible(false);
		myGraphPaper.removeSelect();
		
		SwingUtilities.invokeLater(myRepainter);	
	}
	
	/*
	 * ,   1.
	 */
	private void step1() {
		myGraphPanel.removeAll();
		myGraphPanel.add(new JScrollPane(myGraphPaper));
		myGraphPanel.add(myGraphPaper.getTools());
		myGraphPaper.setSelect();
		
		myBackButton.setVisible(true);
		
		SwingUtilities.invokeLater(myRepainter);	
	}
	
	/*
	 * ,   2.
	 */
	private void step2() {
		myGraphPanel.removeAll();
		myWordsPanel = new CreateWords(myGraphPaper.getSelectX1(), myGraphPaper.getSelectY1(),
				myGraphPaper.getSelectX2(), myGraphPaper.getSelectY2(), myGraphPaper.myCells, 
				myGraphPaper.myLines, myGraphPaper.mySigns);
		
		myGraphPanel.add(new JScrollPane(myWordsPanel));
		
		SwingUtilities.invokeLater(myRepainter);	
	}
	
	/**
	 *  .
	 * 
	 * @param frame ,    .
	 */
	public CreateRebus(RebusForm frame) {
		super("Create Rebus");
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		
		myFrame = frame;
		
		myGraphPaper = new GraphPaper();
		myNextButton = new JButton("Next >");
		myNextButton.addKeyListener(new KeyListener() {
			public void keyTyped(KeyEvent e) {
				myGraphPaper.dispatchEvent(e);
			}

			public void keyPressed(KeyEvent e) {
				myGraphPaper.dispatchEvent(e);
			}

			public void keyReleased(KeyEvent e) {
				myGraphPaper.dispatchEvent(e);
			}
		});
		myNextButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		myNextButton.addActionListener(new AbstractAction() {
			private static final long serialVersionUID = 1L;
			public void actionPerformed(ActionEvent e) {
				if (myStep == 0) {
					if (myGraphPaper.myCells.size() == 0) {
						JOptionPane.showMessageDialog(CreateRebus.this, "    .", "", 0);
						return;
					} 
					step1();
				} else if (myStep == 1) {
					step2();					
				} else if (myStep == 2) {
					if (myWordsPanel.myRelations.size() == 0) {
						JOptionPane.showMessageDialog(CreateRebus.this, "    .", "", 0);
						return;
					} 
					myFrame.setRebus(myWordsPanel.getRebus());
					CreateRebus.this.setVisible(false);
				}
				myStep++;
			}
		});
		
		myBackButton = new JButton("< Back");
		myBackButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		myBackButton.setVisible(false);
		myBackButton.addActionListener(new AbstractAction() {
			private static final long serialVersionUID = 1L;
			public void actionPerformed(ActionEvent e) {
				if (myStep == 1) {
					step0();
				} else if (myStep == 2) {
					step1();					
				}
				myStep--;
			}
		});
				
		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
				
		buttonPanel.setMaximumSize(new Dimension(350, 50));
		buttonPanel.add(myBackButton);
		buttonPanel.add(myNextButton);
				
		myGraphPanel = new JPanel();
		myGraphPanel.setLayout(new BoxLayout(myGraphPanel, BoxLayout.X_AXIS));
		
		step0();
		
		myGraphPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		getContentPane().add(myGraphPanel);
		getContentPane().add(Box.createVerticalStrut(10));
		getContentPane().add(buttonPanel);
		getContentPane().add(Box.createVerticalStrut(10));
		
		setSize(700, 550);
		setVisible(true);
	}
	
	/*
	 * -.
	 */
	private class Repainter implements Runnable {
		public void run() {
			myGraphPanel.repaint();
			myGraphPanel.revalidate();
			CreateRebus.this.repaint();
		}
	}
}
