package org.olga.rebus.gui.creation;

/**
 * -   .
 * 
 * @author Olga
 * @see GraphPaper
 *
 */
public class ModelGraphPaper {
	// 
	private final Position[][] myField;
	
	/**
	 *  .   .
	 * 
	 * @param size  .
	 */
	ModelGraphPaper(int size) {
		this(size, size);
	}
	
	/**
	 *  .   .
	 * 
	 * @param width  .
	 * @param height  .
	 */
	ModelGraphPaper(int width, int height) {
		myField = new Position[width][height];
		for (int i = 0; i < width; i++) {
			for (int j = 0; j < height; j++) {
				myField[i][j] = new Position(i,j);
			}
		}
	}
	
	/**
	 * ,    .
	 * 
	 * @param x  x.
	 * @param y  y.
	 * @return .
	 */
	Position getCellPosition(int x, int y) {
		if ((x > myField.length - 1) || (y > myField[0].length - 1) 
				|| (x < 0) || (y < 0)) {
			return null;
		}
		return myField[x][y];
	}
	
	/*
	 *  -.
	 */
	static class Position {
		int myX;
		int myY;
		
		Position(int x, int y) {
			myX = x;
			myY = y;
		}
	}
}
