package org.olga.rebus.structure;

import java.util.LinkedList;

import org.olga.rebus.structure.Rebus.*;


/**
 * ,  8   .
 *      .
 * 
 * @author Olga
 *
 */
public class TestRebuses {
	//
	public final static Rebus REBUS_1 = rebus1();
	public final static Rebus REBUS_2 = rebus2();
	public final static Rebus REBUS_3 = rebus3();
	public final static Rebus REBUS_4 = rebus4();
	public final static Rebus REBUS_5 = rebus5();
	public final static Rebus REBUS_6 = rebus6();
	public final static Rebus REBUS_7 = rebus7();
	public final static Rebus REBUS_8 = rebus8();

	/**
	 *  .
	 * 
	 *   SIX * TWO = TWELVE
	 * 
	 * @return     .
	 */
	private static Rebus rebus1(){
		
		//SIX
		AbstractSymbol[] six = new AbstractSymbol[3];
		six[0] = new LetterSymbol("S");
		six[1] = new LetterSymbol("I");
		six[2] = new LetterSymbol("X");
		Word wordSix = new Word(six);
		
		//TWO
		AbstractSymbol[] two = new AbstractSymbol[3];
		two[0] = new LetterSymbol("T");
		two[1] = new LetterSymbol("W");
		two[2] = new LetterSymbol("O");
		Word wordTwo = new Word(two);
		
		//TWELVE
		AbstractSymbol[] twelve = new AbstractSymbol[6];
		twelve[0] = two[0];
		twelve[1] = two[1];
		twelve[2] = new LetterSymbol("E");
		twelve[3] = new LetterSymbol("L");
		twelve[4] = new LetterSymbol("V");
		twelve[5] = twelve[2];
		Word wordTwelve = new Word(twelve);
		
		LinkedList<AbstractRelation> rebus1 = new LinkedList<AbstractRelation>();
		rebus1.add(new MultiplyRelation(wordSix, wordTwo, wordTwelve));
		
		//MultiplyRelation[] rebus1 = new MultiplyRelation[1];
		//rebus1[0] = new MultiplyRelation(wordSix, wordTwo, wordTwelve);
		
		LinkedList<VisibleWord> words = new LinkedList<VisibleWord>();
		words.add(new VisibleWord(wordTwo, 8, 0));
		words.add(new VisibleWord(wordSix, 0, 0));
		words.add(new VisibleWord(wordTwelve, 16, 0));
		
		LinkedList<VisibleSign> signs = new LinkedList<VisibleSign>();
		signs.add(new VisibleSign('*', 6, 0));
		signs.add(new VisibleSign('=', 14, 0));
		
		LinkedList<AbstractWord> enumWords = new LinkedList<AbstractWord>();
		//AbstractWord w2 = rebus1[0].getOp2();
		//AbstractWord w3 = rebus1[0].getResult();
		enumWords.add(wordTwo);
		enumWords.add(wordTwelve);
		
		Rebus rebus = new Rebus(rebus1, words, signs, null);
		rebus.setEnumWords(enumWords);
		return rebus;
	}
	
	/**
	 *  .
	 * 
	 *    * 5 = 
	 * 
	 * @return     .
	 */
	private static Rebus rebus2() {
		//
		AbstractSymbol[] sorok = new AbstractSymbol[5];
		sorok[0] = new LetterSymbol("");
		sorok[1] = new LetterSymbol("");
		sorok[2] = new LetterSymbol("");
		sorok[3] = sorok[1];
		sorok[4] = new LetterSymbol("");
		Word wordSorok = new Word(sorok);
		
		//5
		AbstractSymbol[] s5 = new AbstractSymbol[1];
		s5[0] = new NumberSymbol(5);
		Word wordS5 = new Word(s5);
		
		//
		AbstractSymbol[] dvesti = new AbstractSymbol[6];
		dvesti[0] = new LetterSymbol("");
		dvesti[1] = new LetterSymbol("");
		dvesti[2] = new LetterSymbol("");
		dvesti[3] = sorok[0];
		dvesti[4] = new LetterSymbol("");
		dvesti[5] = new LetterSymbol("");
		Word wordDvesti = new Word(dvesti);
		
		LinkedList<AbstractRelation> rebus2 = new LinkedList<AbstractRelation>();
		rebus2.add(new MultiplyRelation(wordSorok, wordS5, wordDvesti));
		
		//MultiplyRelation[] rebus2 = new MultiplyRelation[1];
		//rebus2[0] = new MultiplyRelation(wordSorok, wordS5, wordDvesti);
		
		LinkedList<VisibleWord> words = new LinkedList<VisibleWord>();
		words.add(new VisibleWord(wordSorok, 0, 0));
		words.add(new VisibleWord(wordS5, 12, 0));
		words.add(new VisibleWord(wordDvesti, 16, 0));
		
		LinkedList<VisibleSign> signs = new LinkedList<VisibleSign>();
		signs.add(new VisibleSign('*', 10, 0));
		signs.add(new VisibleSign('=', 14, 0));
		
		LinkedList<AbstractWord> enumWords = new LinkedList<AbstractWord>();
		//AbstractWord w1 = rebus2[0].getOp1();
		//AbstractWord w2 = rebus2[0].getOp2();
		enumWords.add(wordSorok);
		enumWords.add(wordS5);
		
		Rebus rebus = new Rebus(rebus2, words, signs, null);
		rebus.setEnumWords(enumWords);
		
		return rebus;
	}
	
	/**
	 *  .
	 * 
	 *    
	 *   +
	 *   -----
	 *   
	 * 
	 * @return     .
	 */
	private static Rebus rebus3() {
		//
		AbstractSymbol[] odin = new AbstractSymbol[4];
		odin[0] = new LetterSymbol("");
		odin[1] = new LetterSymbol("");
		odin[2] = new LetterSymbol("");
		odin[3] = new LetterSymbol("");
		Word wordOdin = new Word(odin);
		
		//
		AbstractSymbol[] mnogo = new AbstractSymbol[5];
		mnogo[0] = new LetterSymbol("");
		mnogo[1] = odin[3];
		mnogo[2] = odin[0];
		mnogo[3] = new LetterSymbol("");
		mnogo[4] = odin[0];
		Word wordMnogo = new Word(mnogo);
		
		LinkedList<AbstractRelation> rebus3 = new LinkedList<AbstractRelation>();
		rebus3.add(new AdditionRelation(wordOdin, wordOdin, wordMnogo));
		
		//AdditionRelation[] rebus3 = new AdditionRelation[1];
		//rebus3[0] = new AdditionRelation(wordOdin, wordOdin, wordMnogo);
		
		Word wordOdin1 = new Word(odin);
		
		LinkedList<VisibleWord> words = new LinkedList<VisibleWord>();
		words.add(new VisibleWord(wordOdin, 2, 0));
		words.add(new VisibleWord(wordOdin1, 2, 2));
		words.add(new VisibleWord(wordMnogo, 0, 4));
		
		LinkedList<VisibleSign> signs = new LinkedList<VisibleSign>();
		signs.add(new VisibleSign('+', 1, 1));
		
		LinkedList<VisibleLine> lines = new LinkedList<VisibleLine>();
		lines.add(new VisibleLine(-1, 3, 9, 3));
		
		LinkedList<AbstractWord> enumWords = new LinkedList<AbstractWord>();
		//AbstractWord w1 = rebus3[0].getOp1();
		//AbstractWord w2 = rebus3[0].getOp2();
		enumWords.add(wordOdin);
		enumWords.add(wordOdin);
		
		Rebus rebus = new Rebus(rebus3, words, signs, lines);
		rebus.setEnumWords(enumWords);
		
		return rebus;
	}
	
	/**
	 *  .
	 * 
	 *    + 8 = 3
	 *    -   -    -
	 *    +  = 
	 *    =   =    =
	 *    + 3 = 
	 * 
	 * @return     .
	 */
	private static Rebus rebus4() {
		//
		AbstractSymbol[] ab = new AbstractSymbol[2];
		ab[0] = new LetterSymbol("");
		ab[1] = new LetterSymbol("");
		Word wordAb = new Word(ab);
		
		//8
		AbstractSymbol[] s8 = new AbstractSymbol[1];
		s8[0] = new NumberSymbol(8);
		Word wordS8 = new Word(s8);
		
		//3
		AbstractSymbol[] v3 = new AbstractSymbol[2];
		v3[0] = new NumberSymbol(3);
		v3[1] = new LetterSymbol("");
		Word wordV3 = new Word(v3);
		
		LinkedList<AbstractRelation> rebus4 = new LinkedList<AbstractRelation>();
		// + 8 = 3
		rebus4.add(new AdditionRelation(wordAb, wordS8, wordV3));
		
		//AdditionRelation[] rebus4 = new AdditionRelation[6];
		// + 8 = 3
		//rebus4[0] = new AdditionRelation(wordAb, wordS8, wordV3);
		
		//
		AbstractSymbol[] gd = new AbstractSymbol[2];
		gd[0] = new LetterSymbol("");
		gd[1] = new LetterSymbol("");
		Word wordGd = new Word(gd);
		
		//
		AbstractSymbol[] b = new AbstractSymbol[1];
		b[0] = v3[1];
		Word wordB = new Word(b);
		
		//
		AbstractSymbol[] gv = new AbstractSymbol[2];
		gv[0] = gd[0];
		gv[1] = v3[1];
		Word wordGv = new Word(gv);
		
		// +  = 
		rebus4.add(new AdditionRelation(wordGd, wordB, wordGv));
		//rebus4[1] = new AdditionRelation(wordGd, wordB, wordGv);
		
		//
		AbstractSymbol[] gb = new AbstractSymbol[2];
		gb[0] = gd[0];
		gb[1] = ab[1];
		Word wordGb = new Word(gb);
		
		//3
		AbstractSymbol[] s3 = new AbstractSymbol[1];
		s3[0] = new NumberSymbol(3);
		Word wordS3 = new Word(s3);
		
		//
		AbstractSymbol[] ad = new AbstractSymbol[2];
		ad[0] = ab[0];
		ad[1] = gd[1];
		Word wordAd = new Word(ad);
		
		// + 3 = 
		rebus4.add(new AdditionRelation(wordGb, wordS3, wordAd));
		//rebus4[2] = new AdditionRelation(wordGb, wordS3, wordAd);
		
		// -  = 
		rebus4.add(new AdditionRelation(wordGd, wordGb, wordAb));
		//rebus4[3] = new AdditionRelation(wordGd, wordGb, wordAb);
		//8 -  = 
		rebus4.add(new AdditionRelation(wordB, wordS3, wordS8));
		//rebus4[4] = new AdditionRelation(wordB, wordS3, wordS8);
		//3 -  = 
		rebus4.add(new AdditionRelation(wordGv, wordAd, wordV3));
		//rebus4[5] = new AdditionRelation(wordGv, wordAd, wordV3);
		
		LinkedList<VisibleWord> words = new LinkedList<VisibleWord>();
		words.add(new VisibleWord(wordAb, 0, 0));
		words.add(new VisibleWord(wordS8, 6, 0));
		words.add(new VisibleWord(wordV3, 10, 0));
		words.add(new VisibleWord(wordGd, 0, 4));
		words.add(new VisibleWord(wordB, 6, 4));
		words.add(new VisibleWord(wordGv, 10, 4));
		words.add(new VisibleWord(wordGb, 0, 8));
		words.add(new VisibleWord(wordS3, 6, 8));
		words.add(new VisibleWord(wordAd, 10, 8));
		
		LinkedList<VisibleSign> signs = new LinkedList<VisibleSign>();
		signs.add(new VisibleSign('+', 4, 0));
		signs.add(new VisibleSign('=', 8, 0));
		signs.add(new VisibleSign('+', 4, 4));
		signs.add(new VisibleSign('=', 8, 4));
		signs.add(new VisibleSign('+', 4, 8));
		signs.add(new VisibleSign('=', 8, 8));
		signs.add(new VisibleSign('-', 1, 2));
		signs.add(new VisibleSign('-', 6, 2));
		signs.add(new VisibleSign('-', 11, 2));
		signs.add(new VisibleSign('=', 1, 6));
		signs.add(new VisibleSign('=', 6, 6));
		signs.add(new VisibleSign('=', 11, 6));
		
		LinkedList<AbstractWord> enumWords = new LinkedList<AbstractWord>();
		//AbstractWord w1 = rebus4[0].getOp1();
		//AbstractWord w2 = rebus4[1].getOp1();
		enumWords.add(wordAb);
		enumWords.add(wordGd);
		
		Rebus rebus = new Rebus(rebus4, words, signs, null);
		rebus.setEnumWords(enumWords);
		
		return rebus;
		
	}
	
	/**
	 *  .
	 * 
	 *  _*****|**
	 *   ***  |---
	 *   ---- |*8*
	 *   _***
	 *     **
	 *    ----
	 *    _***
	 *     ***
	 *     ---
	 *       0
	 * 
	 * @return     .
	 */
	private static Rebus rebus5() {
		
		AbstractSymbol[] delimoe = new AbstractSymbol[5];
		for(int i=0; i < 5; i++) {
			delimoe[i] = new AsteriskSymbol();
		}
		Word wordDelimoe = new Word(delimoe);
		
		AbstractSymbol[] delitel = new AbstractSymbol[2];
		delitel[0] = new AsteriskSymbol();
		delitel[1] = new AsteriskSymbol();
		Word wordDelitel = new Word(delitel);
		
		AbstractSymbol[] chastn = new AbstractSymbol[3];
		chastn[0] = new AsteriskSymbol();
		chastn[1] = new NumberSymbol(8);
		chastn[2] = new AsteriskSymbol();
		Word wordChastn = new Word(chastn);
		
		LinkedList<AbstractRelation> rebus5 = new LinkedList<AbstractRelation>();
		rebus5.add(new MultiplyRelation(wordDelitel, wordChastn, wordDelimoe));
		
		//AbstractRelation[] rebus5 = new AbstractRelation[7];
		//rebus5[0] = new MultiplyRelation(wordDelitel, wordChastn, wordDelimoe);
		
		AbstractSymbol[] ch1 = new AbstractSymbol[1];
		ch1[0] = chastn[0];
		Word wordCh1 = new Word(ch1);
		
		AbstractSymbol[] z1 = new AbstractSymbol[3];
		for(int i=0; i < 3; i++) {
			z1[i] = new AsteriskSymbol();
		}
		Word wordZ1 = new Word(z1);
		
		rebus5.add(new MultiplyRelation(wordCh1, wordDelitel, wordZ1));
		//rebus5[1] = new MultiplyRelation(wordCh1, wordDelitel, wordZ1);
		
		AbstractSymbol[] z2 = new AbstractSymbol[2];
		for(int i=0; i < 2; i++) {
			z2[i] = new AsteriskSymbol();
		}
		Word wordZ2 = new Word(z2);
		
		AbstractSymbol[] ch2 = new AbstractSymbol[1];
		ch2[0] = chastn[1];
		Word wordCh2 = new Word(ch2);
		
		rebus5.add(new MultiplyRelation(wordDelitel, wordCh2, wordZ2));
		//rebus5[2] = new MultiplyRelation(wordDelitel, wordCh2, wordZ2);
		
		AbstractSymbol[] z3 = new AbstractSymbol[3];
		for(int i=0; i < 3; i++) {
			z3[i] = new AsteriskSymbol();
		}
		Word wordZ3 = new Word(z3);
		
		AbstractSymbol[] ch3 = new AbstractSymbol[1];
		ch3[0] = chastn[2];
		Word wordCh3 = new Word(ch3);
		
		rebus5.add(new MultiplyRelation(wordDelitel, wordCh3, wordZ3));
		//rebus5[3] = new MultiplyRelation(wordDelitel, wordCh3, wordZ3);
		
		AbstractSymbol[] delim3 = new AbstractSymbol[3];
		for(int i=0; i < 3; i++) {
			delim3[i] = delimoe[i];
		}
		Word wordDelim3 = new Word(delim3);
		
		AbstractSymbol[] x1 = new AbstractSymbol[2];
		for(int i=0; i < 2; i++) {
			x1[i] = new AsteriskSymbol();
		}
		Word wordX1 = new Word(x1);
		
		rebus5.add(new AdditionRelation(wordX1, wordZ1, wordDelim3));
		//rebus5[4] = new AdditionRelation(wordX1, wordZ1, wordDelim3);
		
		AbstractSymbol[] y1 = new AbstractSymbol[3];
		y1[0] = x1[0];
		y1[1] = x1[1];
		y1[2] = delimoe[3];
		Word wordY1 = new Word(y1);
		
		AbstractSymbol[] x2 = new AbstractSymbol[2];
		x2[0] = new AsteriskSymbol();
		x2[1] = new AsteriskSymbol();
		Word wordX2 = new Word(x2);
		
		rebus5.add(new AdditionRelation(wordZ2, wordX2, wordY1));
		//rebus5[5] = new AdditionRelation(wordZ2, wordX2, wordY1);
		
		AbstractSymbol[] y2 = new AbstractSymbol[3];
		y2[0] = x2[0];
		y2[1] = x2[1];
		y2[2] = delimoe[4];
		Word wordY2 = new Word(y2);
		
		AbstractSymbol[] s0 = new AbstractSymbol[1];
		s0[0] = new NumberSymbol(0);
		Word wordS0 = new Word(s0);
		
		rebus5.add(new AdditionRelation(wordS0, wordZ3, wordY2));
		//rebus5[6] = new AdditionRelation(wordS0, wordZ3, wordY2);
		
		LinkedList<VisibleWord> words = new LinkedList<VisibleWord>();
		words.add(new VisibleWord(wordDelimoe, 2, 0));
		words.add(new VisibleWord(wordDelitel, 12, 0));
		words.add(new VisibleWord(wordChastn, 12, 2));
		words.add(new VisibleWord(wordZ1, 2, 2));
		words.add(new VisibleWord(wordZ2, 6, 6));
		words.add(new VisibleWord(wordZ3, 6, 10));
		words.add(new VisibleWord(wordY1, 4, 4));
		words.add(new VisibleWord(wordY2, 6, 8));
		words.add(new VisibleWord(wordS0, 10, 12));
		
		LinkedList<VisibleSign> signs = new LinkedList<VisibleSign>();
		signs.add(new VisibleSign('-', 1, 1));
		signs.add(new VisibleSign('-', 3, 5));
		signs.add(new VisibleSign('-', 5, 9));
		
		LinkedList<VisibleLine> lines = new LinkedList<VisibleLine>();
		lines.add(new VisibleLine(11, -1, 11, 3));
		lines.add(new VisibleLine(1, 3, 7, 3));
		lines.add(new VisibleLine(3, 7, 9, 7));
		lines.add(new VisibleLine(5, 11, 11, 11));
		lines.add(new VisibleLine(11, 1, 17, 1));
		
		LinkedList<AbstractWord> enumWords = new LinkedList<AbstractWord>();
		//AbstractWord w1 = rebus5[0].getOp1();
		//AbstractWord w2 = rebus5[0].getOp2();
		enumWords.add(wordDelitel);
		enumWords.add(wordChastn);
		
		Rebus rebus = new Rebus(rebus5, words, signs, lines);
		rebus.setEnumWords(enumWords);
		
		return rebus;
	}
	
	/**
	 *  .
	 * 
	 *     1995
	 *     ***
	 *     ----
	 *    *****
	 *   *
	 *   ------
	 *   
	 * 
	 * @return     .
	 */
	private static Rebus rebus6() {
		//1995
		AbstractSymbol[] s1995 = new AbstractSymbol[4];
		s1995[0] = new NumberSymbol(1);
		s1995[1] = new NumberSymbol(9);
		s1995[2] = s1995[1];
		s1995[3] = new NumberSymbol(5);
		Word wordS1995 = new Word(s1995);
		
		AbstractSymbol[] z1 = new AbstractSymbol[1];
		z1[0] = new AsteriskSymbol();
		Word wordZ1 = new Word(z1);
		
		AbstractSymbol[] z5 = new AbstractSymbol[5];
		for(int i=0; i < 5; i++) {
			z5[i] = new AsteriskSymbol();
		}
		Word wordZ5 = new Word(z5);
		
		LinkedList<AbstractRelation> rebus6 = new LinkedList<AbstractRelation>();
		rebus6.add(new MultiplyRelation(wordS1995, wordZ1, wordZ5));
		
		//AbstractRelation[] rebus6 = new AbstractRelation[5];
		//rebus6[0] = new MultiplyRelation(wordS1995, wordZ1, wordZ5);
		
		AbstractSymbol[] s0 = new AbstractSymbol[1];
		s0[0] = new NumberSymbol(0);
		Word wordS0 = new Word(s0);
		
		rebus6.add(new MultiplyRelation(wordS1995, wordS0, wordS0));
		//rebus6[1] = new MultiplyRelation(wordS1995, wordS0, wordS0);
		
		AbstractSymbol[] z3 = new AbstractSymbol[1];
		z3[0] = new AsteriskSymbol();
		Word wordZ3 = new Word(z3);
		
		//
		AbstractSymbol[] god= new AbstractSymbol[4];
		god[0] = new AsteriskSymbol();
		god[1] = new LetterSymbol("");
		god[2] = new LetterSymbol("");
		god[3] = new LetterSymbol("");
		Word wordGod = new Word(god);
		
		rebus6.add(new MultiplyRelation(wordS1995, wordZ3, wordGod));
		//rebus6[2] = new MultiplyRelation(wordS1995, wordZ3, wordGod);
		
		AbstractSymbol[] s100 = new AbstractSymbol[3];
		s100[0] = new NumberSymbol(1);
		s100[1] = new NumberSymbol(0);
		s100[2] = s100[1];
		Word wordS100 = new Word(s100);
		
		DummyWord word3 = new DummyWord();
		
		rebus6.add(new MultiplyRelation(wordGod, wordS100, word3));
		//rebus6[3] = new MultiplyRelation(wordGod, wordS100, word3);
		
		//
		AbstractSymbol[] svin = new AbstractSymbol[6];
		svin[0] = new LetterSymbol("");
		svin[1] = new LetterSymbol("");
		svin[2] = new LetterSymbol("");
		svin[3] = new LetterSymbol("");
		svin[4] = new LetterSymbol("");
		svin[5] = svin[2];
		Word wordSvin = new Word(svin);
		
		rebus6.add(new AdditionRelation(wordZ5, word3, wordSvin));
		//rebus6[4] = new AdditionRelation(wordZ5, word3, wordSvin);
		
		AbstractSymbol[] multiplier = new AbstractSymbol[3];
		multiplier[0] = z3[0];
		multiplier[1] = s0[0];
		multiplier[2] = z1[0];
		Word wordMultiplier = new Word(multiplier);
		
		LinkedList<VisibleWord> words = new LinkedList<VisibleWord>();
		words.add(new VisibleWord(wordS1995, 4, 0));
		words.add(new VisibleWord(wordZ5, 2, 4));
		words.add(new VisibleWord(wordGod, 0, 6));
		words.add(new VisibleWord(wordSvin, 0, 8));
		words.add(new VisibleWord(wordMultiplier, 6, 2));
		
		LinkedList<VisibleSign> signs = new LinkedList<VisibleSign>();
		signs.add(new VisibleSign('*', 3, 1));
		signs.add(new VisibleSign('+', 0, 5));
		
		LinkedList<VisibleLine> lines = new LinkedList<VisibleLine>();
		lines.add(new VisibleLine(3, 3, 11, 3));
		lines.add(new VisibleLine(-1, 7, 11, 7));
		
		LinkedList<AbstractWord> enumWords = new LinkedList<AbstractWord>();
		//AbstractWord w1 = rebus6[0].getOp1();
		//AbstractWord w2 = rebus6[0].getOp2();
		//AbstractWord w3 = rebus6[2].getOp2();
		enumWords.add(wordS1995);
		enumWords.add(wordZ1);
		enumWords.add(wordZ3);
		
		Rebus rebus = new Rebus(rebus6, words, signs, lines);
		rebus.setEnumWords(enumWords);
		
		return rebus;
	}
	
	/**
	 *  .
	 * 
	 *  _*****|**
	 *   ***  |---
	 *   ---- |*8*
	 *   _***
	 *     **
	 *    ----
	 *    _***
	 *     ***
	 *     ---
	 *       0
	 * 
	 * @return     .
	 */
	private static Rebus rebus7() {
		
		AbstractSymbol[] delimoe = new AbstractSymbol[5];
		for(int i=0; i < 5; i++) {
			delimoe[i] = new AsteriskSymbol();
		}
		Word wordDelimoe = new Word(delimoe);
		
		AbstractSymbol[] delitel = new AbstractSymbol[2];
		delitel[0] = new AsteriskSymbol();
		delitel[1] = new AsteriskSymbol();
		Word wordDelitel = new Word(delitel);
		
		AbstractSymbol[] chastn = new AbstractSymbol[3];
		chastn[0] = new AsteriskSymbol();
		chastn[1] = new NumberSymbol(8);
		chastn[2] = new AsteriskSymbol();
		Word wordChastn = new Word(chastn);
		
		LinkedList<AbstractRelation> rebus5 = new LinkedList<AbstractRelation>();
		rebus5.add(new MultiplyRelation(wordDelitel, wordChastn, wordDelimoe));
		
		//AbstractRelation[] rebus5 = new AbstractRelation[9];
		//rebus5[0] = new MultiplyRelation(wordDelitel, wordChastn, wordDelimoe);
		
		AbstractSymbol[] ch1 = new AbstractSymbol[1];
		ch1[0] = chastn[0];
		Word wordCh1 = new Word(ch1);
		
		
		
		AbstractSymbol[] z1 = new AbstractSymbol[3];
		for(int i=0; i < 3; i++) {
			z1[i] = new AsteriskSymbol();
		}
		Word wordZ1 = new Word(z1);
		
		rebus5.add(new MultiplyRelation(wordCh1, wordDelitel, wordZ1));
		//rebus5[1] = new MultiplyRelation(wordCh1, wordDelitel, wordZ1);
		
		AbstractSymbol[] z2 = new AbstractSymbol[2];
		for(int i=0; i < 2; i++) {
			z2[i] = new AsteriskSymbol();
		}
		Word wordZ2 = new Word(z2);
		
		AbstractSymbol[] ch2 = new AbstractSymbol[1];
		ch2[0] = chastn[1];
		Word wordCh2 = new Word(ch2);
		
		
		rebus5.add(new MultiplyRelation(wordDelitel, wordCh2, wordZ2));
		//rebus5[2] = new MultiplyRelation(wordDelitel, wordCh2, wordZ2);
		
		AbstractSymbol[] z3 = new AbstractSymbol[3];
		for(int i=0; i < 3; i++) {
			z3[i] = new AsteriskSymbol();
		}
		Word wordZ3 = new Word(z3);
		
		AbstractSymbol[] ch3 = new AbstractSymbol[1];
		ch3[0] = chastn[2];
		Word wordCh3 = new Word(ch3);
		
		rebus5.add(new MultiplyRelation(wordDelitel, wordCh3, wordZ3));
		//rebus5[3] = new MultiplyRelation(wordDelitel, wordCh3, wordZ3);
		
		AbstractSymbol[] delim3 = new AbstractSymbol[3];
		for(int i=0; i < 3; i++) {
			delim3[i] = delimoe[i];
		}
		Word wordDelim3 = new Word(delim3);
		
		
		AbstractSymbol[] x1 = new AbstractSymbol[2];
		for(int i=0; i < 2; i++) {
			x1[i] = new AsteriskSymbol();
		}
		Word wordX1 = new Word(x1);
		
		rebus5.add(new AdditionRelation(wordX1, wordZ1, wordDelim3));
		//rebus5[4] = new AdditionRelation(wordX1, wordZ1, wordDelim3);
		
		AbstractSymbol[] q1 = new AbstractSymbol[1];
		q1[0] = delimoe[3];
		Word wordQ1 = new Word (q1);
		
		AbstractSymbol[] q2 = new AbstractSymbol[1];
		q2[0] = new AsteriskSymbol();
		Word wordQ2 = new Word (q2);
		
		rebus5.add(new EqualityRelation(wordQ1, wordQ2));
		//rebus5[7] = new EqualityRelation(wordQ1, wordQ2);
		
		AbstractSymbol[] y1 = new AbstractSymbol[3];
		y1[0] = x1[0];
		y1[1] = x1[1];
		y1[2] = q1[0];
		Word wordY1 = new Word(y1);
		
		AbstractSymbol[] x2 = new AbstractSymbol[2];
		x2[0] = new AsteriskSymbol();
		x2[1] = new AsteriskSymbol();
		Word wordX2 = new Word(x2);
		
		rebus5.add(new AdditionRelation(wordZ2, wordX2, wordY1));
		//rebus5[5] = new AdditionRelation(wordZ2, wordX2, wordY1);
		
		AbstractSymbol[] q3 = new AbstractSymbol[1];
		q3[0] = delimoe[4];
		Word wordQ3 = new Word (q3);
		
		AbstractSymbol[] q4 = new AbstractSymbol[1];
		q4[0] = new AsteriskSymbol();
		Word wordQ4 = new Word (q4);
		
		rebus5.add(new EqualityRelation(wordQ3, wordQ4));
		//rebus5[8] = new EqualityRelation(wordQ3, wordQ4);
		
		AbstractSymbol[] y2 = new AbstractSymbol[3];
		y2[0] = x2[0];
		y2[1] = x2[1];
		y2[2] = q3[0];
		Word wordY2 = new Word(y2);
		
		AbstractSymbol[] s0 = new AbstractSymbol[1];
		s0[0] = new NumberSymbol(0);
		Word wordS0 = new Word(s0);
		
		rebus5.add(new AdditionRelation(wordS0, wordZ3, wordY2));
		//rebus5[6] = new AdditionRelation(wordS0, wordZ3, wordY2);
		
		LinkedList<Subword> substrings = new LinkedList<Subword>();
		substrings.add(new Subword(wordChastn, wordCh1, 0, 1));
		substrings.add(new Subword(wordChastn, wordCh2, 1, 2));
		substrings.add(new Subword(wordChastn, wordCh3, 2, 3));
		substrings.add(new Subword(wordDelimoe, wordDelim3, 0, 3));
		substrings.add(new Subword(wordDelimoe, wordQ1, 3, 4));
		substrings.add(new Subword(wordY2, wordQ4, 2, 3));
		substrings.add(new Subword(wordY1, wordX1, 0, 2));
		substrings.add(new Subword(wordY1, wordQ2, 2, 3));
		substrings.add(new Subword(wordDelimoe, wordQ3, 4, 5));
		
		LinkedList<VisibleWord> words = new LinkedList<VisibleWord>();
		words.add(new VisibleWord(wordDelimoe, 2, 0));
		words.add(new VisibleWord(wordDelitel, 12, 0));
		words.add(new VisibleWord(wordChastn, 12, 2));
		words.add(new VisibleWord(wordZ1, 2, 2));
		words.add(new VisibleWord(wordZ2, 6, 6));
		words.add(new VisibleWord(wordZ3, 6, 10));
		words.add(new VisibleWord(wordY1, 4, 4));
		words.add(new VisibleWord(wordY2, 6, 8));
		words.add(new VisibleWord(wordS0, 10, 12));
		
		LinkedList<VisibleSign> signs = new LinkedList<VisibleSign>();
		signs.add(new VisibleSign('-', 1, 1));
		signs.add(new VisibleSign('-', 3, 5));
		signs.add(new VisibleSign('-', 5, 9));
		
		LinkedList<VisibleLine> lines = new LinkedList<VisibleLine>();
		lines.add(new VisibleLine(11, -1, 11, 3));
		lines.add(new VisibleLine(1, 3, 7, 3));
		lines.add(new VisibleLine(3, 7, 9, 7));
		lines.add(new VisibleLine(5, 11, 11, 11));
		lines.add(new VisibleLine(11, 1, 17, 1));
		
		LinkedList<AbstractWord> enumWords = new LinkedList<AbstractWord>();
		//AbstractWord w1 = rebus5[0].getOp1();
		//AbstractWord w2 = rebus5[0].getOp2();
		enumWords.add(wordDelitel);
		enumWords.add(wordChastn);
		
		Rebus rebus = new Rebus(rebus5, words, signs, lines);
		rebus.setEnumWords(enumWords);
		rebus.setSubwords(substrings);
		
		return rebus;
	}
	
	/**
	 *  .
	 * 
	 *     1995
	 *     ***
	 *     ----
	 *    *****
	 *   *
	 *   ------
	 *   
	 * 
	 * @return     .
	 */
	private static Rebus rebus8() {
		//1995
		AbstractSymbol[] s1995 = new AbstractSymbol[4];
		s1995[0] = new NumberSymbol(1);
		s1995[1] = new NumberSymbol(9);
		s1995[2] = s1995[1];
		s1995[3] = new NumberSymbol(5);
		Word wordS1995 = new Word(s1995);
		
		AbstractSymbol[] z1 = new AbstractSymbol[1];
		z1[0] = new AsteriskSymbol();
		Word wordZ1 = new Word(z1);
		
		AbstractSymbol[] z5 = new AbstractSymbol[5];
		for(int i=0; i < 5; i++) {
			z5[i] = new AsteriskSymbol();
		}
		Word wordZ5 = new Word(z5);
		
		LinkedList<AbstractRelation> rebus6 = new LinkedList<AbstractRelation>();
		rebus6.add(new MultiplyRelation(wordS1995, wordZ1, wordZ5));
		
		//AbstractRelation[] rebus6 = new AbstractRelation[9];
		//rebus6[0] = new MultiplyRelation(wordS1995, wordZ1, wordZ5);
		
		AbstractSymbol[] s0 = new AbstractSymbol[1];
		s0[0] = new NumberSymbol(0);
		Word wordS0 = new Word(s0);
		
		rebus6.add(new MultiplyRelation(wordS1995, wordS0, wordS0));
		//rebus6[1] = new MultiplyRelation(wordS1995, wordS0, wordS0);
		
		AbstractSymbol[] z3 = new AbstractSymbol[1];
		z3[0] = new AsteriskSymbol();
		Word wordZ3 = new Word(z3);
		
		//
		AbstractSymbol[] god= new AbstractSymbol[4];
		god[0] = new AsteriskSymbol();
		god[1] = new LetterSymbol("");
		god[2] = new LetterSymbol("");
		god[3] = new LetterSymbol("");
		Word wordGod = new Word(god);
		
		rebus6.add(new MultiplyRelation(wordS1995, wordZ3, wordGod));
		//rebus6[2] = new MultiplyRelation(wordS1995, wordZ3, wordGod);
		
		AbstractSymbol[] s100 = new AbstractSymbol[3];
		s100[0] = new NumberSymbol(1);
		s100[1] = new NumberSymbol(0);
		s100[2] = s100[1];
		Word wordS100 = new Word(s100);
		
		DummyWord word3 = new DummyWord();
		
		rebus6.add(new MultiplyRelation(wordGod, wordS100, word3));
		//rebus6[3] = new MultiplyRelation(wordGod, wordS100, word3);
		
		//
		AbstractSymbol[] svin = new AbstractSymbol[6];
		svin[0] = new LetterSymbol("");
		svin[1] = new LetterSymbol("");
		svin[2] = new LetterSymbol("");
		svin[3] = new LetterSymbol("");
		svin[4] = new LetterSymbol("");
		svin[5] = svin[2];
		Word wordSvin = new Word(svin);
		
		rebus6.add(new AdditionRelation(wordZ5, word3, wordSvin));
		//rebus6[4] = new AdditionRelation(wordZ5, word3, wordSvin);
		
		AbstractSymbol[] multiplier = new AbstractSymbol[3];
		multiplier[0] = new AsteriskSymbol();
		multiplier[1] = new NumberSymbol(0);
		multiplier[2] = new AsteriskSymbol();
		Word wordMultiplier = new Word(multiplier);
		
		AbstractSymbol[] m = new AbstractSymbol[1];
		m[0] = multiplier[0];
		Word wordM = new Word(m);
		
		rebus6.add(new EqualityRelation(wordM, wordZ3));
		//rebus6[5] = new EqualityRelation(wordM, wordZ3);
		
		AbstractSymbol[] m1 = new AbstractSymbol[1];
		m1[0] = multiplier[1];
		Word wordM1 = new Word(m1);
		
		rebus6.add(new EqualityRelation(wordM1, wordS0));
		//rebus6[6] = new EqualityRelation(wordM1, wordS0);
		
		AbstractSymbol[] m2 = new AbstractSymbol[1];
		m2[0] = multiplier[2];
		Word wordM2 = new Word(m2);
		
		rebus6.add(new EqualityRelation(wordM2, wordZ1));
		//rebus6[7] = new EqualityRelation(wordM2, wordZ1);
		
		rebus6.add(new MultiplyRelation(wordMultiplier,  wordS1995, wordSvin));
		//rebus6[8] = new MultiplyRelation(wordMultiplier,  wordS1995, wordSvin);
		
		LinkedList<Subword> substrings = new LinkedList<Subword>();
		substrings.add(new Subword(wordMultiplier, wordZ1, 2, 3));
		substrings.add(new Subword(wordMultiplier, wordZ3, 0, 1));
		substrings.add(new Subword(wordMultiplier, wordS0, 1, 2));
		
		LinkedList<VisibleWord> words = new LinkedList<VisibleWord>();
		words.add(new VisibleWord(wordS1995, 4, 0));
		words.add(new VisibleWord(wordZ5, 2, 4));
		words.add(new VisibleWord(wordGod, 0, 6));
		words.add(new VisibleWord(wordSvin, 0, 8));
		words.add(new VisibleWord(wordMultiplier, 6, 2));
		
		LinkedList<VisibleSign> signs = new LinkedList<VisibleSign>();
		signs.add(new VisibleSign('*', 3, 1));
		signs.add(new VisibleSign('+', 0, 5));
		
		LinkedList<VisibleLine> lines = new LinkedList<VisibleLine>();
		lines.add(new VisibleLine(3, 3, 11, 3));
		lines.add(new VisibleLine(-1, 7, 11, 7));
		
		LinkedList<AbstractWord> enumWords = new LinkedList<AbstractWord>();
		//AbstractWord w1 = rebus6[0].getOp1();
		//AbstractWord w2 = rebus6[0].getOp2();
		//AbstractWord w3 = rebus6[2].getOp2();
		enumWords.add(wordS1995);
		enumWords.add(wordZ1);
		enumWords.add(wordZ3);
		
		Rebus rebus = new Rebus(rebus6, words, signs, lines);
		rebus.setEnumWords(enumWords);
		rebus.setSubwords(substrings);
		
		return rebus;
	}
	
}
