package org.olga.test;

import java.util.*;

public class TestCollection {

	private ArrayList<ITest> myTests = new ArrayList<ITest>();

	public void addTest(ITest test) {
		myTests.add(test);
	}

	public void runAllTests(boolean showPassed) {
		int passedCounter = 0;
		int failedCounter = 0;
		for (ITest test: myTests) {
			if (test.run()) {
				if (showPassed) {
					System.out.println(test.name() + ": passed");
				}
				passedCounter++;
			} else {
				System.out.println(test.name() + ": failed");
				failedCounter++;
			}
		}
		System.out.println("Total: " + (passedCounter + failedCounter));
		System.out.println("Passed: " + passedCounter);
		System.out.println("Failed: " + failedCounter);
	}
}
